package com.example.user.kucharka;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

import java.util.ArrayList;
import java.util.List;

public class Database extends SQLiteOpenHelper {
    public static final String KEY_ID = "id";
    public static final String KEY_NAZEV = "nazev";
    public static final String KEY_PRISADY = "prisady";
    public static final String KEY_POPIS = "popis";
    private static final String DATABASE_NAME = "recepty.db";
    private static final String DATABASE_TABLE = "recepty";
    private static final int DATABASE_VERSION = 1;
    SQLiteDatabase db;
    private static final String TABLE_CREATE = "create table recepty (id integer primary key autoincrement," +
            "nazev text not null, prisady text not null, popis text not null)";



    public Database(Context context) {
        super(context, DATABASE_NAME, null, DATABASE_VERSION);
    }






    public void insertRecept(Recept r){
        db = this.getWritableDatabase();
        ContentValues val = new ContentValues();
        val.put(KEY_NAZEV, r.getNazev());
        val.put(KEY_PRISADY, r.getPrisady());
        val.put(KEY_POPIS, r.getPopis());

        db.insert(DATABASE_TABLE, null, val);
        db.close();
    }



    public List<String> getAllReceptsName(){
        List<String> list = new ArrayList<String>();
        SQLiteDatabase db = this.getReadableDatabase();
        Cursor c = db.rawQuery("SELECT * FROM recepty", null);
        if(c!=null){
            c.moveToFirst();
        }
        do{
            String nazev = c.getString(1);
            list.add(nazev);
        }while(c.moveToNext());
        return list;
    }






    public void deleteRecept(String nazev){
        SQLiteDatabase db = this.getWritableDatabase();
        db.delete(DATABASE_TABLE, KEY_NAZEV + "= ?", new String[] { nazev });
        db.close();
    }





    public Recept getRecept(String nazev){
        SQLiteDatabase db = this.getReadableDatabase();
        Cursor cursor = db.query(DATABASE_TABLE, new String[] { KEY_ID,
                        KEY_NAZEV, KEY_PRISADY, KEY_POPIS }, KEY_NAZEV + "=?",
                new String[] { String.valueOf(nazev) }, null, null, null, null);
        if(cursor!=null){
            cursor.moveToFirst();
        }
        return new Recept(cursor.getString(1), cursor.getString(2), cursor.getString(3));
    }




    public boolean existRecept(String nazev){
        try{
            SQLiteDatabase db = this.getReadableDatabase();
            Recept r = getRecept(nazev);
            Cursor cursor = db.query(DATABASE_TABLE, new String[]{KEY_ID,
                            KEY_NAZEV, KEY_PRISADY, KEY_POPIS}, KEY_NAZEV + "=?",
                    new String[]{String.valueOf(nazev)}, null, null, null, null);
            if(cursor!=null){
                return true;
            }
        }catch (Exception e) {}
          return false;

        }



    @Override
    public void onCreate(SQLiteDatabase db) {
        db.execSQL(TABLE_CREATE);
        this.db = db;
    }

    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
        String quary = "DROP TABLE IF EXITS recepty";
        db.execSQL(quary);
        this.onCreate(db);
    }
}
