package com.example.user.kucharka;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.LauncherActivity;
import android.content.ClipData;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.ActivityInfo;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.util.Log;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.ListView;
import android.view.View;
import android.widget.Toast;

import java.util.ArrayList;
import java.util.List;

public class VyberReceptu extends Activity {

    ListView listV;
    ArrayAdapter<String> adapter;
    EditText etSear;
    Context context = this;
    Alert Alert = new Alert(context);
    AlertYorN YN = new AlertYorN(context);

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_vyber_receptu);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_NOSENSOR);

        etSear = (EditText)findViewById(R.id.etVyhledat);
        listV = (ListView)findViewById(R.id.list);

        FirstOn();
        zaplnitLV();
        }

    public void PridatRecept(View v){
        Intent i = new Intent(this, PridatRecept.class);
        startActivity(i);
        finish();
    }

    public void WebRecepts(View v){
        Intent i = new Intent(VyberReceptu.this, WebReceptsActivity.class);
        startActivity(i);
        finish();
    }

    public void Hledat(View v){
        String n = etSear.getText().toString();
        if(!n.equals("")){
            try{
                Database db = new Database(context);
                if(db.existRecept(n)) {
                    listV.setAdapter(adapter = new ArrayAdapter<String>(
                            VyberReceptu.this,
                            R.layout.list_item,
                            new String[]{n}
                    ));

                }else{
                    listV.setAdapter(adapter = new ArrayAdapter<String>(
                            VyberReceptu.this,
                            R.layout.list_item,
                            new String[]{"Nenalezen zadny recept!"}
                    ));
                    listV.setOnItemClickListener(null);
                }
                db.close();
            }catch(Exception e){
                Alert.show("Chyba", "Chyba ve vyhledavani!");
            }
        }
    }



    private void zaplnitLV(){
        try {
            Database db = new Database(this);

            listV.setAdapter(adapter = new ArrayAdapter<String>(
                    VyberReceptu.this,
                    R.layout.list_item,
                    db.getAllReceptsName()
            ));
            LVoption();
            db.close();

        }catch (Exception e){
            listV.setAdapter(adapter = new ArrayAdapter<String>(
                    VyberReceptu.this,
                    R.layout.list_item,
                    new String[]{"Nenalezen zadny recept!"}
            ));
            listV.setOnItemClickListener(null);
        }
    }



    private void LVoption(){
        listV.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, final int position, long id) {
                AlertDialog.Builder builder = new AlertDialog.Builder(context)
                        .setTitle("Vyber").setMessage("vyber:")
                        .setCancelable(false).setPositiveButton("Otevrit", new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                Intent i = new Intent(VyberReceptu.this, OtevritReceptActivity.class);
                                Database db = new Database(context);
                                Recept recept = db.getRecept(listV.getItemAtPosition(position).toString());
                                i.putExtra("nazev", recept.getNazev());
                                i.putExtra("prisady", recept.getPrisady());
                                i.putExtra("popis", recept.getPopis());
                                startActivity(i);
                                finish();
                            }
                        })

                        .setNegativeButton("Smazat", new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                YN.show("Vymazat", "Chcete vymazat recept:  " + listV.getItemAtPosition(position).toString() + " ?", new DialogInterface.OnClickListener() {
                                    @Override
                                    public void onClick(DialogInterface dialog, int which) {
                                        try {
                                            Database db = new Database(context);
                                            db.deleteRecept(listV.getItemAtPosition(position).toString());
                                            db.close();
                                            Toast.makeText(context, "Uspesne smazan!", Toast.LENGTH_LONG).show();
                                            zaplnitLV();
                                        } catch (Exception e) {
                                            Alert.show("Chyba", "Chyba ve smazavani!");
                                        }
                                    }
                                });
                            }
                        });
                AlertDialog dialog = builder.create();
                dialog.show();
            }
        });
    }


    public void reload(View v){
        zaplnitLV();
    }




    private void FirstOn() {
        SharedPreferences sp = getSharedPreferences("first", MODE_PRIVATE);
        if (sp.getBoolean("first", true)) {
            Database db = new Database(context);


            db.insertRecept(new Recept("Smazene karbenatky",
                    "1 ks cibule\n" +
                    " 500 g mleté maso\n 1 ks vejce\n 100 ml studená voda\n" +
                    " 5 stroužkůčesnek mletý černý pepř\n  majoránka\n  mletý kmín\n" +
                    " sůl\n  petrželka\n olej na smažení\n 2 lžíce hladká mouka\n" +
                    " strouhanka",
                    "Mleté maso smícháme s vodou a necháme asi 30 minut v chladu odpočinout," +
                            " aby bylo šťavnatější. Malou cibuli oloupeme a nasekáme najemno.\n" +
                            "\n" +
                            "Pak přidáme vejce, pepř, kmín, majoránku, prolisovaný česnek nebo " +
                            "lžičku sušeného česneku, petrželku nebo pažitku, sůl, cibuli, mouku a strouhanku podle potřeby. Hmotu dobře propracujeme. Ze směsi tvarujeme karbanátky, které obalujeme ve strouhance. Karbanátky smažíme v rozehřátém tuku po obou stranách dozlatova.\n" +
                            "\n" +
                            "Smažené karbanátky podáváme s bramborovou kaší, " +
                            "sypanou nakrájenou jarní cibulkou a s čerstvou zeleninou. Smažené karbanátky podáváme ihned." +
                            "  (zdroj:   www.recepty.vareni.cz)"));


            db.insertRecept(new Recept("Domaci kecup",
                            "3 ks hřebíček\n 150 m l8% ocet\n 5 kuliček celé nové koření\n" +
                            " 25 dkg cibule\n 2 kg rajče\n 1 špetka mletá skořice\n" +
                            " 10 kuliček celý černý pepř\n 1 lžíce sůl\n 150 ml voda\n" +
                            " 2 ks bobkový list\n 1 lžička mletá sladká paprika\n 15 dkg cukr\n" +
                            " 25 dkg jablko",

                    "Do připraveného kastrolu si nandáme " +
                                    " omytá a přepůlená hodně zralá rajčata, očištěná jablíčka " +
                                    "i se slupkou, oloupanou a nahrubo nasekanou cibuli.\n" +
                                    "\n" +
                                    "Pak přidáme ocet, cukr a veškeré koření. Koření si " +
                                    "můžeme dát do zvláštního obalu, abychom ho potom nemuseli " +
                                    "lovit z kastrolu. Zeleninu vaříme do zhoustnutí, za občasného" +
                                    " míchání, asi 1 hodinu. Záleží na vodnatosti rajčat. Pokud máme" +
                                    " kvalitní kastrol míchat nemusíme.\n" +
                                    "\n" +
                                    "Potom vyndáme obal s kořením a směs na kečup ponorným mixerem " +
                                    "rozmixujeme. Kečupovou směs propasírujeme přes husté síto a " +
                                    "kečup si horký nalijeme do skleniček. Kečup sterilujeme 20 minut. "
                                    +"(zdroj:  www.recepty.vareni.cz)"));


            db.insertRecept(new Recept(
                    "Mlecny koktejl z granka",
                    "2 lžíce cukr moučka\n 500 ml mléko\n 4 lžíce granko\n mleta skorice",
                    "Do rychlošlehače nalijeme mléko. Mléko šleháme tak dlouho, až se objeví pěna.\n" +
                            "\n" +
                            "Do našlehaného mléka přisypeme granko, cukr a skořici a dále koktejl šleháme asi 2 minuty.\n" +
                            "\n" +
                            "Mléčný koktejl z granka přelijeme do skleniček a můžeme podávat. (zdroj:  www.recepty.vareni.cz)"));

            db.close();

            SharedPreferences.Editor editor = sp.edit();
            editor.putBoolean("first", false);
            editor.commit();
        }
    }
}