package com.example.user.kucharka;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.database.Cursor;
import android.inputmethodservice.Keyboard;
import android.inputmethodservice.KeyboardView;
import android.inputmethodservice.KeyboardView.OnKeyboardActionListener;
import android.os.Bundle;
import android.os.Looper;
import android.util.Log;
import android.view.View;
import android.webkit.WebView;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.Toast;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import static android.widget.Toast.*;

public class WebReceptsActivity extends Activity {

    EditText etSear;
    ListView listV;
    List<String> list;
    ArrayAdapter<String> adapter;
    Context context = this;
    Document document;
    Alert Alert = new Alert(context);
    boolean povedlose = true;
    List<String> href;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_web_recepts);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_NOSENSOR);

        etSear = (EditText)findViewById(R.id.etWSear);
        listV = (ListView)findViewById(R.id.wList);
    }

    public void back(View v){
       Intent i = new Intent(context, VyberReceptu.class);
        startActivity(i);
        finish();
    }

    public void WHledat(View v){
        if(!etSear.getText().toString().equals("")) {

            Thread downloadThread = new Thread() {
                public void run() {
                    Document doc = null;
                    try {
                        doc = Jsoup.connect("http://recepty.vareni.cz/vyhledavani/?q="+etSear.getText().toString()).get();

                        try{
                            list = new ArrayList<String>();
                            href = new ArrayList<String>();
                            Elements el = doc.select("ul#list-view.list");
                            Elements es = el.select("li");
                              for(Element e : es){
                                  href.add(e.getElementsByClass("item-title").first().select("a[href]").attr("abs:href"));
                                  list.add(e.getElementsByClass("item-title").first().text());
                              }
                             povedlose = true;
                        }catch(Exception e){
                            Looper.prepare();
                            Alert.show("Chyba", "Nenalezen recept: " + etSear.getText().toString());
                            Looper.loop();
                            povedlose = false;
                       }
                    } catch (IOException e) {
                        Looper.prepare();
                        Alert.show("Chyba", "Nemate pristup k Internetu!");
                        Looper.loop();
                        povedlose = false;
                    }
                }
            };
            downloadThread.start();
            try{
                Thread.sleep(1500);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
            if(povedlose){
                zaplnLV(list);
            }
        }
    }

    private void zaplnLV(List<String> l){
        try {
            listV.setAdapter(adapter = new ArrayAdapter<String>(
                    WebReceptsActivity.this,
                    R.layout.list_item,
                    l
            ));
            LVOption();


        }catch(Exception e){
            listV.setAdapter(adapter = new ArrayAdapter<String>(
                    WebReceptsActivity.this,
                    R.layout.list_item,
                    new String[]{"Nanalezeno!  Je mozne ze nemate pripojeni k Internetu!"}
            ));
            listV.setOnItemClickListener(null);
        }
    }



    private void LVOption(){
        listV.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                String title = parent.getItemAtPosition(position).toString();
                final String url = href.get(position);
                final Intent i = new Intent(context, WebOtevritRecept.class);
                i.putExtra("nazev", parent.getItemAtPosition(position).toString());

                Thread th = new Thread(){
                  public void run(){
                      try{
                          Document doc = Jsoup.connect(url).get();


                          Element prisady = doc.getElementById("recipe-ingredients");
                          Elements items = prisady.select("ul").first().getAllElements();
                          boolean b = true;
                          for(Element e : items) {
                              if(b)
                              i.putExtra("prisady", e.select("dl").text());
                              b = false;
                          }

                          Element popis = doc.getElementById("recipe-procedure");
                          i.putExtra("popis", popis.text());

                          Looper.prepare();
                          startActivity(i);
                          finish();
                          Looper.loop();
                      }catch(IOException e){
                         Looper.prepare();
                          Alert.show("Chyba", "Nemate pristup k Internetu!");
                      }catch(Exception e){
                          Alert.show("Chyba", "Neznama chyba:   "+e);
                      }
                  }
                };
                th.start();
            }
        });
    }
}
